highp float hash( highp float n )
{
return fract(sin(n)*43758.5453);
}

highp float noise( in highp vec2 x )
{
highp vec2 p = floor(x);
highp vec2 f = fract(x);
f = f*f*(3.-2.*f);
highp float n = p.x + p.y*57.;
highp float res = mix(mix( hash(n+  0.), hash(n+  1.),f.x), mix( hash(n+ 57.), hash(n+ 58.),f.x),f.y);
return res;
}
//BSBE NOISE


highp float voronoi(highp vec2 p){
    highp vec2 cell_i = floor(p);
    highp vec2 cell_f = fract(p);
    highp float min_dist = 2.0;
    for(int x = 0; x <= 1; x++){
    for(int y = 0; y <= 1; y++){
 	 highp vec2 xy = vec2(float(x), float(y));
 	 highp float n = dot(cell_i+xy, vec2(1,57));
    highp vec2 point = vec2(hash(n));
    point = 0.3 * sin(
    TIME*0.125 + 6.2831 * point);
    highp float dist = distance(
     	     cell_f, xy + point);
    min_dist = min(min_dist, dist);
        }
    }
	return min_dist;
}
//VORONOISE LITE